#include <string>
#include <typeinfo>

#include <arc/stringconv.h>

#include <cxxabi.h>
#include <libintl.h>
#define _(A) dgettext("arclib", ((A)))


std::string StringConvErrorString(const std::type_info& t, bool empty) {

	char* type = __cxxabiv1::__cxa_demangle(t.name(), NULL, NULL, NULL);
	std::string typestr("unknown type");
	if (type!=NULL) {
		typestr = type;
		free(type);
	}

	if (empty)
		return _("Can not convert empty string to") + (" " + typestr);
	else
		return _("Can not convert string to") + (" " + typestr);
}
